;
; hd.asm
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;; hd [file]
;;
;;   Prints hexadecimal dump of file
;;
;    This file is part of the IDE64 shell utilities.
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

WILDEXP		= false

INPUT_LFN	= 1

offset		= $fb

banner		= "hexdump 0.3 by soci/singular"

		.include "lib.asm"

		.section code
start2		.proc
		ldx #<arglist
		ldy #>arglist
		jsr parseargs

		lda arglist
		ldx #<(arglist+1)
		ldy #>(arglist+1)
		jsr kernal.setnam
		lda #INPUT_LFN
		ldx mydrive
		ldy #0
		sty offset
		sty offset+1
		sty offset+2
		jsr kernal.setlfs
		jsr kernal.open
		bcs _nopen
		jsr loop
		jsr kernal.clrchn
_ninput		lda #INPUT_LFN
		jsr kernal.close
_nopen		jmp exit


loop
		ldx #INPUT_LFN
		jsr kernal.chkin
		bcc +
err		rts
+
		ldx #0
-		jsr kernal.chrin
		ldy kernal.status
		beq +
		cpy #$40
		bne mk
+		sta buffer,x
		inx
		bcs mk
		cpx #8
		blt -

mk		txa
		beq fin
		stx buffl
		sty eof

		ldx #STDOUT_LFN
		jsr kernal.chkout
		bcs err

		ldx #2
-		lda offset,x
		jsr printhex
		dex
		bpl -

		ldy #0
-		lda #" "
		jsr kernal.chrout
		cpy buffl
		blt +
		jsr kernal.chrout
		jsr kernal.chrout
		gcc e
+		lda buffer,y
		jsr printhex
e		iny
		cpy #8
		blt -

		ldy #0
		lda #" "
		jsr kernal.chrout
-		lda #1
		sta kernal.quote
		sta kernal.insert
		lda buffer,y
		cmp #"{cr}"
		beq d
		cmp #"{shift return}"
		bne +
d		lda #" "
+		jsr kernal.chrout
		iny
		cpy buffl
		blt -
		lda #"{cr}"
		jsr kernal.chrout
		lda kernal.status
		bne fin
		lda kernal.stop
		cmp #$7f
		beq fin

		lda offset
		clc
		adc #8
		sta offset
		bcc +
		inc offset+1
		bne +
		inc offset+2
+
		lda eof
		beq loop

fin		rts

		.section bss
buffer		.fill 8
buffl		.byte ?
eof		.byte ?
		.send bss
		.pend
		.send code

